float4x4 matrixWorldViewProj : MATRIX_WORLDVIEWPROJ; //  
float4x4 matrixWorld         : MATRIX_WORLD;         //  
float3   lightDirection      : LIGHT0_DIRECTION;     // 
float4   lightColor          : LIGHT0_COLOR;         // 
float4   entityColor         : COLOR_DIFFUSE;        //  


texture  diffuseTexture     ;          
sampler diffuseSampler = sampler_state
{
	Texture = <diffuseTexture>;   
	AddressU      = WRAP;
	AddressV      = WRAP;
	AddressW      = WRAP; 
	MinFilter     = ANISOTROPIC;
	MagFilter     = ANISOTROPIC;
	MipFilter     = ANISOTROPIC;  
	MaxAnisotropy = 4;
};


texture  Stex1     ;          
sampler Stex1S = sampler_state
{
	Texture = <Stex1>;   
	AddressU      = WRAP;
	AddressV      = WRAP;
	AddressW      = WRAP; 
	MinFilter     = ANISOTROPIC;
	MagFilter     = ANISOTROPIC;
	MipFilter     = ANISOTROPIC;  
	MaxAnisotropy = 4;
};
texture  Stex2     ;          
sampler Stex2S = sampler_state
{
	Texture = <Stex2>;   
	AddressU      = WRAP;
	AddressV      = WRAP;
	AddressW      = WRAP; 
	MinFilter     = ANISOTROPIC;
	MagFilter     = ANISOTROPIC;
	MipFilter     = ANISOTROPIC;  
	MaxAnisotropy = 4;
};
texture  Stex3     ;          
sampler Stex3S = sampler_state
{
	Texture = <Stex3>;   
	AddressU      = WRAP;
	AddressV      = WRAP;
	AddressW      = WRAP; 
	MinFilter     = ANISOTROPIC;
	MagFilter     = ANISOTROPIC;
	MipFilter     = ANISOTROPIC;  
	MaxAnisotropy = 4;
};
   
struct VSInput
{
	float4 position  : POSITION;
	float3 normal    : NORMAL;
	float2 texCoords : TEXCOORD0;
};
    
struct VSOutput
{
	float4 position  : POSITION;
	float3 normal    : TEXCOORD1;
	float2 texCoords : TEXCOORD0;
};
  
VSOutput VSMain(VSInput input)
{    
	VSOutput output;   
	output.position  = mul(input.position, matrixWorldViewProj);   
	output.normal    = normalize(mul(input.normal, matrixWorld));  
	output.texCoords = input.texCoords;  
	return output;
}
 

float4 PSMain(VSOutput input) : COLOR0
{	   
	float4 diffuse = tex2D(diffuseSampler, input.texCoords);
	float lit = dot(input.normal, -lightDirection);
	diffuse=(tex2D(Stex1S, input.texCoords)*diffuse.r)+(tex2D(Stex2S, input.texCoords)*diffuse.g)+(tex2D(Stex3S, input.texCoords)*diffuse.b),1;
	return diffuse * lit * lightColor;
}

technique Diffuse
{
	pass p0
	{
		VertexShader = compile vs_2_0 VSMain();
		PixelShader  = compile ps_2_0 PSMain();
	}
}
